@echo on

setlocal

rem root of mingw installation; modify as required
set mingw=x:\wprogs\msys64\ucrt64

path %mingw%\bin;%path%

set winflags=-D NTDDI_VERSION=0x6010000 -D _WIN32_WINNT=0x0601
set CCFLAGS=-g -O0 %winflags% -municode -Wall -mwindows -fms-extensions
set LDFLAGS=-Wl,-subsystem,windows -municode -static-libgcc -static-libstdc++
set LDLIBS=-lshlwapi -lucrt -ladvapi32

echo 1 ICON "tlmgr.ico">tlshell.rc
windres tlshell.rc tlshell-rc.o
gcc %CCFLAGS% -c -o tlshell.o tlshell.c
c++ tlshell.o tlshell-rc.o %LDFLAGS% %LDLIBS% -o tlshell.exe
strip tlshell.exe
endlocal
